;
; this is a skeleton for passthrough  or resident programs
;
; when compiled as a pass through program it will use a little over
; 5K of system memory. When compiled as resident program it takes
; about 1.5k. When you add your own routines an work areas this
; will increase.
;
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
        db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
scan1   db 30h     ; these are the hot key combinations
shift1  db 10      ; scan being the scan code and shift being
scan2   db 83h     ; the shift state.
shift2  db 12      ;
stack   dw   256  dup(0)
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
cursor    dw  0
cursmode  dw  0
bhpage    db  0
mess1    db  "We're back",13,10,10,'$'
;
; this data is used by the passthru program only
;
if passthru
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
START        PROC        NEAR
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are ppasssed
;
; first call the keyboard interrupt so that it can handle the
; keystroke
;
        pushf          ; fake the way an interrupt pushes flags
        cli
        call cs:int9
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int9_shift
        pop  ax
        iret
int9_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int9_shift:
; no one is using this guy so we will check out the shift state
; this uses two hot keys, one is Alt-Left Shift-B and the other
; is Alt-Ctrl-Equal.
;
        mov  ah,2   ; get shift status
        int  16h    ; get keyboard
; status returns in al
        and  al,0fh ; get rid of caps or num lock stuff
;
        cmp  al,cs:shift1 ; has the Alt and Left shift been pressed
        je   test_hot_1
        cmp  al,cs:shift2 ; has the Alt and Ctrl been pressed
        je   test_hot_2
        jmp  int9_return
test_hot_1:
; check to see if the next key to come in is B  scan 40h
        mov  ah,1
        int  16h
        jnz  check_key1
        jmp  int9_return
check_key1:
        cmp  ah,cs:scan1   ; Is the next character the "B" key?
        je   goforit
        jmp  int9_return
test_hot_2:
; check to see if the next key to come in is =  scan 83h
        mov  ah,1
        int  16h
        jnz  check_key2
        jmp  int9_return
check_key2:
        cmp  ah,cs:scan2  ; Is the next character the "=" key?
        je   goforit
        jmp  int9_return
goforit:
; save the world first switch to the local stack to save the
; actual stack.
; ax is the only thing in the local stack ( plus the interrupt ret)
        sti
        mov   cs:savessl,ss
        mov   cs:savespl,sp
        mov   ax,cs
        mov   ss,ax
        lea   sp,stack+510  ; double duty out of the local stack
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        push ds
        push es
; get the p so others won't be messed up
        mov  ah,0
        int  16h
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        call getcurs   ; gets the current cursor position
;
;
;   the program goes here
         call  blip
;
;
;
exit_prog:
        call retcurs   ; restores the old cursor position
        pop  es
        pop  ds
        pop  bp
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        mov  ss,cs:savessl
        mov  sp,cs:savespl
        pop  ax
        mov   cs:semaphore,0
        iret
START        ENDP
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
setpass  proc  near
; set up a local stack
        lea  sp,stack+510
;
; redirect interrupts here
;
        push  es
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        pop   es
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int9
        mov   ah,25h
        mov   al,9h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
